<?php

/**
 * @file
 * Hooks provided by the Commerce Netbilling module.
 */

/**
 * @defgroup commerce_netbilling_hooks Commerce Netbilling hooks
 * @{
 * Functions to alter requests made to Netbilling's API.
 * @}
 */

/**
 * Respond to checkout success.
 *
 * @param array $request
 *   The request sent to Netbilling. May be partially sanitized.
 * @param array $response
 *   Response from Netbilling.
 * @param object $order
 *   Drupal Commerce order.
 * @param object $transaction
 *   Drupal Commerce transaction.
 *
 * @ingroup commerce_netbilling_hooks
 */
function hook_commerce_netbilling_checkout_success($request, $response, $order, $transaction) {
  // Respond to checkout success here.
}

/**
 * Respond to checkout failure.
 *
 * @param array $request
 *   The request sent to Netbilling. May be partially sanitized.
 * @param array $response
 *   Response from Netbilling.
 * @param object $order
 *   Drupal Commerce order.
 *
 * @ingroup commerce_netbilling_hooks
 */
function hook_commerce_netbilling_checkout_failure($request, $response, $order) {
  // Respond to checkout failure here.
}

/**
 * Alter an API request being built for a Commerce order.
 *
 * @param array $request
 *   The request being built for submission to Netbilling. Not yet complete.
 * @param object $order
 *   Drupal Commerce order.
 *
 * @ingroup commerce_netbilling_hooks
 */
function hook_commerce_netbilling_build_order_request_alter(&$request, $order) {
  // Add elements to $request here.
}

/**
 * Alter an API request (not necessarily for an order).
 *
 * @param array $request
 *   The request being built for submission to Netbilling.
 *   May not necessarily be for an order (e.g., capture).
 *
 * @ingroup commerce_netbilling_hooks
 */
function hook_commerce_netbilling_request_alter(&$request) {
  // Add elements to $request here.
}
